commit 4ff3ad478042f8ec880325c5464d6543c54fef19
Author: Jason D. McCormick <jason@mfamily.org>
Date:   Mon Feb 6 07:16:13 2017 -0500

    Revert "Commit updates to the locale messages as best I can"
    
    This reverts commit 7b25b213ee572f9d5471c29a3b3a1cff99cc55d3.

diff --git a/src/usr/local/share/locale/cs/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/cs/LC_MESSAGES/pfSense.po
index 2b6d13b7f0..2087d3ba22 100644
--- a/src/usr/local/share/locale/cs/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/cs/LC_MESSAGES/pfSense.po
@@ -21505,7 +21505,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/da/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/da/LC_MESSAGES/pfSense.po
index 80757988d9..d95ef15d57 100644
--- a/src/usr/local/share/locale/da/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/da/LC_MESSAGES/pfSense.po
@@ -21493,7 +21493,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/de_DE/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/de_DE/LC_MESSAGES/pfSense.po
index a734c7830f..d268b34f24 100644
--- a/src/usr/local/share/locale/de_DE/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/de_DE/LC_MESSAGES/pfSense.po
@@ -21953,7 +21953,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/es/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/es/LC_MESSAGES/pfSense.po
index 81137f3d4a..979639bd53 100644
--- a/src/usr/local/share/locale/es/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/es/LC_MESSAGES/pfSense.po
@@ -23548,10 +23548,10 @@ msgstr "zona de Identificación"
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
-"Route53: Ingrese la región AWS y el identificador de zona en el formulario REGION/ZONEID (ejemplo: "us-east-1/A1B2C3D4E5F6Z"). <br /"
+"Introduzca ID de zona que se recibió al crear el dominio de la Ruta 53. <br /"
 "> DNSimple: Introduzca el número de registro del registro que desea "
 "actualizar."
 
diff --git a/src/usr/local/share/locale/fi/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/fi/LC_MESSAGES/pfSense.po
index dd501a7805..b8ace0adea 100644
--- a/src/usr/local/share/locale/fi/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/fi/LC_MESSAGES/pfSense.po
@@ -21451,7 +21451,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/fr/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/fr/LC_MESSAGES/pfSense.po
index f0057a4b62..4ac01968b4 100644
--- a/src/usr/local/share/locale/fr/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/fr/LC_MESSAGES/pfSense.po
@@ -21551,7 +21551,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/it/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/it/LC_MESSAGES/pfSense.po
index c2115f437c..cb93ef0491 100644
--- a/src/usr/local/share/locale/it/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/it/LC_MESSAGES/pfSense.po
@@ -21514,7 +21514,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/ja/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/ja/LC_MESSAGES/pfSense.po
index 7f54da3e0a..584eef2ca6 100644
--- a/src/usr/local/share/locale/ja/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/ja/LC_MESSAGES/pfSense.po
@@ -21507,7 +21507,7 @@ msgstr "ゾーンID"
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/nb/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/nb/LC_MESSAGES/pfSense.po
index 97df7a3764..a41a7b7372 100644
--- a/src/usr/local/share/locale/nb/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/nb/LC_MESSAGES/pfSense.po
@@ -21462,7 +21462,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/nl/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/nl/LC_MESSAGES/pfSense.po
index 9e6331a7ab..41ed1f5bec 100644
--- a/src/usr/local/share/locale/nl/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/nl/LC_MESSAGES/pfSense.po
@@ -21501,7 +21501,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/pl/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/pl/LC_MESSAGES/pfSense.po
index cad4dfe42d..c99d708822 100644
--- a/src/usr/local/share/locale/pl/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/pl/LC_MESSAGES/pfSense.po
@@ -21454,7 +21454,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/pot/pfSense.pot b/src/usr/local/share/locale/pot/pfSense.pot
index eb577d0c79..44cf595e39 100644
--- a/src/usr/local/share/locale/pot/pfSense.pot
+++ b/src/usr/local/share/locale/pot/pfSense.pot
@@ -21428,7 +21428,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/pt_BR/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/pt_BR/LC_MESSAGES/pfSense.po
index b9b9456c52..e3ff0c89f2 100644
--- a/src/usr/local/share/locale/pt_BR/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/pt_BR/LC_MESSAGES/pfSense.po
@@ -21964,7 +21964,7 @@ msgstr "Zone ID"
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/ru/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/ru/LC_MESSAGES/pfSense.po
index af101fa954..b02e955697 100644
--- a/src/usr/local/share/locale/ru/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/ru/LC_MESSAGES/pfSense.po
@@ -21462,7 +21462,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/sv/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/sv/LC_MESSAGES/pfSense.po
index 6b8dd9b78e..3e2fded39b 100644
--- a/src/usr/local/share/locale/sv/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/sv/LC_MESSAGES/pfSense.po
@@ -21451,7 +21451,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/tr/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/tr/LC_MESSAGES/pfSense.po
index 4c5da5c63b..ee48fbcc59 100644
--- a/src/usr/local/share/locale/tr/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/tr/LC_MESSAGES/pfSense.po
@@ -21756,7 +21756,7 @@ msgstr "Alan Kimliği (ID)"
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/zh_CN/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/zh_CN/LC_MESSAGES/pfSense.po
index b60147c272..275dade110 100644
--- a/src/usr/local/share/locale/zh_CN/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/zh_CN/LC_MESSAGES/pfSense.po
@@ -21451,7 +21451,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 
diff --git a/src/usr/local/share/locale/zh_Hans_CN/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/zh_Hans_CN/LC_MESSAGES/pfSense.po
index 903f44128f..f51784bc5f 100644
--- a/src/usr/local/share/locale/zh_Hans_CN/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/zh_Hans_CN/LC_MESSAGES/pfSense.po
@@ -21698,7 +21698,7 @@ msgstr "区域ID"
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr "输入在Route 53中创建域时接收的区域ID。<br /> DNSimple：输入要更新的记录的ID。"
 
diff --git a/src/usr/local/share/locale/zh_TW/LC_MESSAGES/pfSense.po b/src/usr/local/share/locale/zh_TW/LC_MESSAGES/pfSense.po
index fcffbc702e..816ce68921 100644
--- a/src/usr/local/share/locale/zh_TW/LC_MESSAGES/pfSense.po
+++ b/src/usr/local/share/locale/zh_TW/LC_MESSAGES/pfSense.po
@@ -21451,7 +21451,7 @@ msgstr ""
 
 #: src/usr/local/www/services_dyndns_edit.php:379
 msgid ""
-"Route53: Enter AWS Region and Zone ID in the form REGION/ZONEID (example: "us-east-1/A1B2C3D4E5F6Z").<br /"
+"Enter Zone ID that was received when creating the domain in Route 53.<br /"
 ">DNSimple: Enter the Record ID of record to update."
 msgstr ""
 